#ifndef _vm
#define _vm

#define False 0
#define True  1
#define FALSE 0
#define TRUE  1

#define Yes 'Y'
#define No 'N'

#define Ignore_error 0
#define Display_error 1
#define Terminate_on_error 2

#define norm_text_col   LIGHTGRAY
#define norm_bkg_col    BLACK
#define norm_var_col    WHITE
#define title_front_col CYAN
#define title_bkg_col   BLUE
#define menu_front_col  YELLOW
#define menu_bkg_col    BLACK
#define moka_front_col  MAGENTA
#define moka_bkg_col    BLACK
#define menu_arrow_col  RED

#define F1 59
#define F2 60
#define F3 61
#define F4 62
#define F5 63
#define F6 64
#define F7 65
#define F8 66
#define F9 67
#define F10 68
#define ESC 27

struct patch
  {
    int   pat_num;
    int   mdc;
    int   *mdv;
//    int   *captures;
//    int   *recaps;
    float x_pos;
    float y_pos;
    float area;
    float isolation;
    float mu;
    float p_surv;
    float edge_prop;
    float *ro;
  };

struct m_day
  {
    int   mpc;
    int   *mpv;
    int   next_md;
    int   prev_md;
    int   **nijt;
    int   *ni1t;
    int   *ni2t;
    int   *N;
    float *gi1t;
    float *gi2t;
    float *vi1t;
    float *vi2t;
    float ENt;
    float V1;
    float V2;
    float V3;
    float EVARt;
    float ECOVt;
    float ksi;
    int   nt1;
    int   nt2;
    float ro;
    float ro1;
    float **p1r;
  };

struct butterfly
  {
    int num;
    int cpc;
    int *cpv;
    int *ctv;
    int sex;
    int color;
    int oper;
    double lh;
  };

struct lls {
       struct lls *pb;
	     struct lls *pf;
	     char       *lls_text;
	   };

#endif



