#ifndef _NR_UTILS_H_
#define _NR_UTILS_H_

static float sqrarg;
#define SQR(a) ((sqrarg=(a))==0.0 ? 0.0 : sqrarg*sqrarg )
/*
static double dsqrarg;
#define DSQR(a) ((dsqrarg=(a))==0.0 ? 0.0 : dsqrarg*daqrarg )

static double dmaxarg1, dmaxarg2;
#define DMAX(a,b) (dmaxarg=(a), dmaxarg2=(b), (dmaxarg1)>(dmaxarg2) ? (dmaxarg1) : (dmaxarg2))

static double dminarg1, dminarg2;
#define DMIN(a,b) (dminarg=(a), dminarg2=(b), (dminarg1)>(dminarg2) ? (dminarg1) : (dminarg2))

static float fmaxarg1, fmaxarg2;
#define FMAX(a,b) (fmaxarg=(a), fmaxarg2=(b), (fmaxarg1)>(fmaxarg2) ? (fmaxarg1) : (dmaxarg2))

static float fminarg1, fminarg2;
#define FMIN(a,b) (fminarg=(a), fminarg2=(b), (fminarg1)>(fminarg2) ? (fminarg1) : (fminarg2))

static long lmaxarg1, lmaxarg2;
#define LMAX(a,b) (lmaxarg=(a), lmaxarg2=(b), (lmaxarg1)>(lmaxarg2) ? (lmaxarg1) : (lmaxarg2))

static int iminarg1, iminarg2;
#define IMIN(a,b) (iminarg=(a), iminarg2=(b), (iminarg1)>(iminarg2) ? (iminarg1) : (iminarg2))

static long lminarg1, lminarg2;
#define LMIN(a,b) (lminarg=(a), lminarg2=(b), (lminarg1)>(lminarg2) ? (lminarg1) : (lminarg2))

static int imaxarg1, imaxarg2;
#define IMAX(a,b) (imaxarg=(a), imaxarg2=(b), (imaxarg1)>(imaxarg2) ? (imaxarg1) : (imaxarg2))

*/

#define SIGN(a,b) ((b) > 0.0 ? fabs(a) : -fabs(a))

/* #if defined (__STDC__) || defined(ANSI) || defined(NRANSI)  ansi */

void   nrerror(char error_text[]);
void   Mat_multip(float **dest, float **m1, float **m2, int rows);
float  *vector(long nl, long nh);
int    *ivector(int nl, int nh);
float  **matrix( long nrl, long nrh, long ncl, long nch);
char   **cmatrix( long nrl, long nrh, long ncl, long nch);
int    **imatrix(long nrl, long nrh, long ncl, long nch);
float  **submatrix(float **a, long oldrl, long oldrh, long oldcl, long oldch,
                   long newrl, long newcl);
//float  **convert_matrix(float *a, long nrl, long nrh, long ncl, long nch);
//float  ***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh);
int    **Lower_triangular_matrix(long nrl, long nrh);
float  **Lower_triangular_fmatrix(long nrl, long nrh);
void   free_vector(float *v, long nl, long nh);
void   free_ivector(int  *v, long nl, long nh);
void   free_matrix(float    **m, long nrl, long nrh, long ncl, long nch);
void   free_cmatrix(char    **m, long nrl, long nrh, long ncl, long nch);
void   free_imatrix(int     **m, long nrl, long nrh, long ncl, long nch);
void   free_submatrix(int   **b, long nrl, long nrh, long ncl, long nch);
//void   free_convert_matrix(int **b, long nrl, long nrh, long ncl, long nch);
//void   free_f3tensor(float ***t, long nrl, long nrh, long ncl, long nch, long ndl, long ndh);
void   Free_ltm(int **m, long nrl, long nrh);
void   Free_ltfm(float **m, long nrl, long nrh);

/* #else  ANSI */
/* traditional K&R */

/* #endif  ANSI */

#endif /* _NR_UTILS_H_ */


