#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <dos.h>
#include <process.h>
#include "vmcl2.h"
#include "kbio.h"

extern char output_file_name[];
extern int  prints, rap_mode;

/*************************** Check_errors ***********************************/
void Check_errors(char *f_name, char *file_type, int error_handling) {

switch (error_handling) {
  case Ignore_error : break;
  case Display_error :
    Show_var_txt(1,2,"Error opening %s file %s ", file_type, f_name);
    break;
  case Terminate_on_error :
    Show_var_txt(1,2,"Error opening %s file %s ", file_type, f_name);
    Terminate(1,2,"Terminating abnormally, check files");
    break;
  }
}

/************************** Open_file ***************************************/
FILE *Open_file(char *f_name, char *mode_str,
		char *file_type, int error_handling) {
static FILE *rf;
rf = fopen(f_name, mode_str);
if (!rf)
  Check_errors(f_name, file_type, error_handling);
return rf;
}


FILE *rf=NULL;

/************ Add_to_rap_file ********************************************/
void Add_to_rap_file(char *str)
{

  if (rf==NULL)
     rf=Open_file(output_file_name, "a+t", "raport", Terminate_on_error);

  fprintf(rf,"%s", str);
  if (!rap_mode)
    {
      fclose(rf);
      rf=NULL;
    }
}

/*************** Close_rap_file *****************************************/
void Close_rap_file()
{
  fclose(rf);
  rf=NULL;
}


/************ Raport *****************************************************/
void Raport(char *fmt, ...)
{
  static struct text_info ti;
  va_list ap;
  char    txt[256];

  gettextinfo(&ti);
  Col(moka_front_col, moka_bkg_col);

  va_start(ap, fmt);
  vsprintf(txt, fmt, ap);

  if (prints)
    printf("%s", txt);
  Add_to_rap_file(txt);
  textattr(ti.attribute);
  va_end(ap);
}
